/* 
   Copyright (c) 2004-2005 by Igor B. Kuznetsov. All Rights Reserved.
   IKuznetsov@albany.edu

   Licensor hereby grants to any person a permission to use, copy and distribute any part of this software
   program for educational and non-profit purposes, without fee, and without a written agreement,
   provided that this copyright notice appears in all copies. You cannot modify this source code without 
   an explicit written permission of the author. 

   Any unauthorized commercial distribution of any part of this software program is strictly prohibited. 

   This software is provided on an "AS IS" BASIS and WITHOUT WARRANTY, either express or implied, 
   including, without limitation, the warranties of NON-INFRINGEMENT, MERCHANTABILITY 
   or FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY OF THE SOFTWARE IS WITH YOU.

   Limitation of Liability. Under no circumstances and under no legal theory shall the Licensor be liable 
   to any person for any direct, indirect, special, incidental, or consequential damages of any character 
   arising as a result of the use of this software. 
*/

#ifndef _LIB_H_

#define _LIB_H_

#include <stdio.h>

#define Max(a,b)  (((a) > (b)) ? (a) : (b))
#define Min(a,b)  (((a) < (b)) ? (a) : (b))

struct FileList {
				char fname[200];
				char **name;
				int n;
                };

/* Structure for reading FASTA sequence file */
struct FASTA_FILE {
						  int n;
						  int *l;
						  char **name;
						  char **seq;
						  FILE *fil;
						};

void AverVar(long n,double *val,double *aver,double *stddev);
double Median(long n,double *val);
int ReadFileList(char *fname,struct FileList *p);
int ReadFastaFile(struct FASTA_FILE*);
int ReadFastaEntry(struct FASTA_FILE*,int);

#define log2(x) (log(x)/0.693147180559945309417232121458177)

double read_double(FILE*);
double sread_double(char*);
long read_long(FILE*);
long sread_long(char*);
int read_int(FILE*);
int sread_int(char*);
double read_doubleu(FILE*);
void init_ran1(long seed);
double ran1(double);
char *CreateUniqueFile(char *name);

#endif


